;Prueba de descompresion RLE
; Desempaquetamos un SCR comprimido con RLE sobre la pantalla
ORG 35000

    ; Cargamos los datos y preparamos nuestra rutina
    LD HL, Pantalla_Comprimida
    LD DE, 16384
    LD BC, 2571
    CALL RLE_decompress

Wait_For_Keys_Pressed:
    XOR A                        ; A = 0
    IN A, (254)
    OR 224
    INC A
    JR Z, Wait_For_Keys_Pressed

salir:
    RET

;;
;; RLE_decompress
;; Descomprime un bloque de datos RLE de memoria a memoria.
;;
;; Entrada a la rutina:
;;
;; HL = dirección origen de los datos RLE.
;; DE = destino donde descomprimir los datos.
;; BC = tamaño de los datos comprimidos.
;;
RLE_decompress:

RLE_dec_loop:
    LD A, (HL)                         ; leemos un byte

    CP 192
    JP NC, RLE_dec_compressed          ; si byte > 192 = está comprimido
    LD (DE), A                         ; si no está comprimido, escribirlo
    INC DE
    INC HL
    DEC BC

RLE_dec_loop2:
    LD A,B
    OR C
    JR NZ, RLE_dec_loop
    RET                                 ; miramos si hemos acabado

RLE_dec_compressed:                    ; bucle para descompresión
    PUSH BC
    AND 63                              ; cogemos el numero de repeticiones
    LD B, A                             ; lo salvamos en B
    INC HL                              ; y leemos otro byte (dato a repetir)
    LD A, (HL)

RLE_dec_loop3:
    LD (DE), A                          ; bucle de escritura del dato B veces
    INC DE
    DJNZ RLE_dec_loop3
    INC HL
    POP BC                              ; recuperamos BC
    DEC BC                              ; Este DEC BC puede hacer BC=0 si los datos
                                        ; RLE no correctos. Cuidado (mem-smashing).
    DEC BC
    JR RLE_dec_loop2
    RET


Pantalla_Comprimida:
    INCBIN sokoban.rle


END 35000
